package com.company.sample.screen.customer;

import com.company.sample.app.CustomerService;
import io.jmix.core.LoadContext;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.TextField;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import com.company.sample.entity.Customer;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@UiController("Customer.browse")
@UiDescriptor("customer-browse.xml")
@LookupComponent("customersTable")
public class CustomerBrowse extends StandardLookup<Customer> {

    @Autowired
    private CustomerService customerService;

    @Autowired
    private CollectionLoader<Customer> customersDl;

    @Autowired
    private TextField<String> firstNameFilter;

    @Autowired
    private TextField<String> lastNameFilter;

    @Install(to = "customersDl", target = Target.DATA_LOADER)
    private List<Customer> customersDlLoadDelegate(LoadContext<Customer> loadContext) {
        String firstNameFilterValue = firstNameFilter.getValue();
        String lastNameFilterValue = lastNameFilter.getValue();
        return customerService.loadCustomers(firstNameFilterValue, lastNameFilterValue);
    }

    @Subscribe("refreshBtn")
    public void onRefreshBtnClick(Button.ClickEvent event) {
        customersDl.load();
    }

}